<ui:composition xmlns:s="http://jboss.org/schema/seam/taglib"
                xmlns:gdk="http://www.ihe.net/gazellecdk"
                xmlns:h="http://java.sun.com/jsf/html"
                xmlns:rich="http://richfaces.org/rich"
                xmlns:f="http://java.sun.com/jsf/core"
                xmlns:a4j="http://richfaces.org/a4j"
                xmlns:ui="http://java.sun.com/jsf/facelets"
                xmlns:g="http://www.ihe.net/gazelle"
                xmlns="http://www.w3.org/1999/xhtml"
                template="//layout/template.xhtml">
    <ui:define name="body">
        <h:form>
            <!--<s:token id="settingsToken" allowMultiplePosts="true"/>-->
            <s:div id="globalDiv">

                <a4j:commandButton action="#{applicationManager.createNewPreference()}"
                                   styleClass="gzl-btn pull-right" execute="settingsToken"
                                   value="#{messages['net.ihe.gazelle.proxy.AddAPreference']}"
                                   oncomplete="jq162('#addPrefModal').modal('show');"
                                   render="prefInputs"/>

                <h2><span class="fa fa-wrench" style="font-size: 1em;"></span>
                    #{messages['net.ihe.gazelle.proxy.ApplicationPreferences']}</h2>

                <rich:dataTable id="prefList" value="#{applicationManager.getAllPreferences()}" var="pref">
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.proxy.NameuniqueKey']}</ui:define>
                        <h:outputText value="#{pref.variable}"/>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.proxy.Value']}</ui:define>
                        <rich:inplaceInput value="#{pref.value}" defaultLabel="&#160;&#160;&#160;&#160;"
                                           inputWidth="80%" showControls="true"
                                           title="#{messages['net.ihe.gazelle.atna.ClickToEdit']}">
                            <a4j:ajax event="change" render="globalDiv"
                                      listener="#{applicationManager.updatePreference(pref)}"/>
                        </rich:inplaceInput>
                    </g:column>
                    <g:column>
                        <ui:define name="header">#{messages['net.ihe.gazelle.atna.Actions']}</ui:define>
                        <div class="gzl-never-wrap">
                            <a4j:commandLink event="click" title="#{messages['net.ihe.gazelle.atna.Delete']}"
                                             oncomplete="jq162('#delPrefModal').modal('show');"
                                             render=" :prefOutputs" execute="@this"
                                             actionListener="#{applicationManager.setPreference(pref) }">
                                <span class="gzl-icon-trash-o"/>
                            </a4j:commandLink>
                        </div>
                    </g:column>
                </rich:dataTable>

                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="addPrefModal"/>
                    <ui:define name="popup_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.NewApplicationPreference']}"/>
                    </ui:define>

                    <s:div id="prefInputs" styleClass="form-horizontal">
                        <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                            <ui:param name="id" value="inputVaria"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.atna.PreferenceNameuniqueKey']})
                            </ui:define>
                            <h:inputText id="inputVaria" type="text" styleClass="form-control"
                                         value="#{applicationManager.preference.variable}"/>
                        </s:decorate>
                        <s:decorate template="/layout/form/_form_field_horizontal_4-8.xhtml">
                            <ui:param name="id" value="inputValue"/>
                            <ui:define name="label">#{messages['net.ihe.gazelle.atna.PreferenceValue']}</ui:define>
                            <h:inputText id="inputValue" styleClass="form-control"
                                         value="#{applicationManager.preference.value}"/>
                        </s:decorate>
                    </s:div>

                    <ui:define name="popup_footer">
                        <a4j:commandButton styleClass="gzl-btn"
                                           value="#{messages['net.ihe.gazelle.atna.Cancel']}"
                                           actionListener="#{applicationManager.setPreference(null)}"
                                           oncomplete="jq162('#addPrefModal').modal('hide')"/>
                        <a4j:commandButton styleClass="gzl-btn-blue"
                                           value="#{messages['net.ihe.gazelle.atna.Save']}"
                                           action="#{applicationManager.savePreference(applicationManager.preference)}"
                                           oncomplete="jq162('#addPrefModal').modal('hide')"
                                           render="prefList"/>
                    </ui:define>
                </ui:decorate>

                <ui:decorate template="/layout/popup/_popup_title_footer.xhtml">
                    <ui:param name="popup_id" value="delPrefModal"/>
                    <ui:define name="popup_title">
                        <h:outputText value="#{messages['net.ihe.gazelle.atna.DeletePreference']}"/>
                    </ui:define>

                    <s:div id="prefOutputs" styleClass="form-horizontal">
                        <s:decorate template="/layout/display/_display.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.NameuniqueKey']}
                            </ui:define>
                            <h:outputText value="#{applicationManager.preference.variable}"/>
                        </s:decorate>
                        <s:decorate template="/layout/display/_display.xhtml">
                            <ui:define name="label">#{messages['net.ihe.gazelle.proxy.Value']}</ui:define>
                            <h:outputText value="#{applicationManager.preference.value}"/>
                        </s:decorate>
                    </s:div>

                    <ui:define name="popup_footer">
                        <a4j:commandButton styleClass="gzl-btn"
                                           value="#{messages['net.ihe.gazelle.atna.Cancel']}"
                                           actionListener="#{applicationManager.setPreference(null)}"
                                           oncomplete="jq162('#delPrefModal').modal('hide')"/>
                        <a4j:commandButton styleClass="gzl-btn-red"
                                           value="#{messages['net.ihe.gazelle.atna.Delete']}"
                                           action="#{applicationManager.removeSelectedPreference()}"
                                           oncomplete="jq162('#delPrefModal').modal('hide')"
                                           render="prefList"/>
                    </ui:define>
                </ui:decorate>

            </s:div>
        </h:form>
    </ui:define>
</ui:composition>
